<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>
<script>
    $(document).ready(function () {
        onPageLoad();

        $("#table-users").on("click", ".button-edit-user", function () {
            onEditUserClick(this);
        });
        $("#table-users").on("click", ".button-delete-user", function () {
            onDeleteUserClick(this);
        });
        $("#table-users").on("click", ".button-add-user", function () {
            onAddUserClick(this);
        });
    });

    function onPageLoad() {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "GET",
            success: function (paramUsers) {
                loadDataToTable(paramUsers);
            },
            error: function (paramErrors) {
                console.log(paramErrors);
            }
        });
    }
    //hàm gọi khi ấn nút sửa
    function onEditUserClick(btnEdit) {
        console.log("Edit button click : " + $(btnEdit).data("id"));
        var vUserId = $(btnEdit).data("id");
        console.log(vUserId);
        const vDETAIL_FORM_URL = "updateUser.html";
        var vUrlToOpenPage = vDETAIL_FORM_URL + "?id=" + vUserId
        window.location.href = vUrlToOpenPage;
    }
    //hàm gọi khi ấn nút Xóa
    function onDeleteUserClick(btnDel) {
        confirm("Are you sure?");
        if (confirm("Are you sure?") == true) {
            console.log("You pressed OK!");
            var vUserId = $(btnDel).data("id");
            console.log("Delete button click : " + $(btnDel).data("id"));
            callAPIDeleteUserById(vUserId);
        } else {
            console.log("You canceled!");
        }
    }

    // hàm gọi API Xóa user
    function callAPIDeleteUserById(vUserId) {
        "use strict";
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + vUserId,
            method: "DELETE",
            contentType: "application/json;charset=UTF-8",
            success: function (response) {
                // Thông báo xóa thành công
                alert("Xóa thành công");

                // Khi xóa thành công quay trở lại trang danh sách người dùng
                window.location.href = "list-users.html";

                console.log(JSON.stringify(res, true, 2));
            },
            error: function (ajaxContext) {
                console.log(ajaxContext);
            }
        });
    }
    
    //hàm gọi khi ấn nút Thêm
    function onAddUserClick() {
        "use strict";
        const vDETAIL_FORM_URL = "insertUser.html";
        var vUrlToOpenPage = vDETAIL_FORM_URL;
        window.location.href = vUrlToOpenPage;
    }

    // Hàm hiển thị data lên bảng
    function loadDataToTable(data) {
        var vTableUsers = $("#table-users");
        for (var index = 0; index < data.length; index++) {
            var newRow = $("<tr>").appendTo(vTableUsers);
            $("<td>", {
                html: data[index].id
            }).appendTo(newRow);
            $("<td>", {
                html: data[index].firstname
            }).appendTo(newRow);
            $("<td>", {
                html: data[index].lastname
            }).appendTo(newRow);
            $("<td>", {
                html: data[index].country
            }).appendTo(newRow);
            $("<td>", {
                html: data[index].subject
            }).appendTo(newRow);
            $("<td>", {
                html: data[index].customerType
            }).appendTo(newRow);
            $("<td>", {
                html: data[index].registerStatus
            }).appendTo(newRow);

            var colAction = $("<td>").appendTo(newRow);
            $("<button>", {
                html: "Sửa",
                class: "btn btn-primary button-edit-user"
            }).data("id", data[index].id).appendTo(colAction);
            $("<button>", {
                html: "Xóa",
                class: "btn btn-danger button-delete-user"
            }).data("id", data[index].id).appendTo(colAction);
            $("<button>", {
                html: "Thêm",
                class: "btn btn-primary button-add-user"
            }).data("id", data[index].id).appendTo(colAction);
        }
    }
</script>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>

</html>